# -*- coding:utf-8 -*-
import serial
import time

import sys

if sys.version_info[0] >= 3:
    input_func = input
else:
    input_func = raw_input

ser = serial.Serial("/dev/serial0", 115200, timeout=1)
print(ser.portstr)
ser.flushInput()

print("You can always send data, press Ctrl + C to exit")
print("Send \"abcdef\" to open relays 1, 2, 3, 4, 5 and 6 respectively\r\n")
print("Send \"123456\" to close relays 1, 2, 3, 4, 5 and 6 respectively\r\n")

data = ""
try:
    while True:
        strInput = input_func('Enter some data: ')
        ser.write(strInput.encode('utf-8') if sys.version_info[0] >= 3 else strInput)
        time.sleep(0.1)
        while ser.inWaiting() > 0:
            data = ser.readline()
            if data != b"":
                print(data.decode('utf-8').strip() if sys.version_info[0] >= 3 else data)
                data = b"" if sys.version_info[0] >= 3 else ""
except KeyboardInterrupt:
    print('Exiting...')
finally:
    ser.close()