# -*- coding:utf-8 -*-
from gpiozero import OutputDevice
import os
import can
import time

relay_devices = [OutputDevice(5), OutputDevice(6), OutputDevice(13), OutputDevice(16), OutputDevice(19), OutputDevice(20)]

for relay in relay_devices:
    relay.off()

os.system('sudo ip link set can0 type can bitrate 100000')
os.system('sudo ifconfig can0 up')

fun = [0xff]
fun1 = 0x00
buff = [0,0]

try:
    can0 = can.Bus(channel='can0', interface='socketcan')
    
    print("You can always receive data, press Ctrl + C to exit\r\n")
    print("Wait for the send configuration to complete\n")
    msg1 = can0.recv(None)
    
    print("Communication established successfully\n")

    while True:
        msg = can0.recv(100)
        if msg is None:
            print('Timeout occurred, no message.')
        else:
            data = msg.data
            print("\nThe data received is : ", data)

            for i, b in enumerate(data):
                if b == 49:  # '1'
                    print("Turn off Relay 1")
                    fun[0] = fun[0] | 0x01
                    relay_devices[0].off()
                elif b == 50:  # '2'
                    print("Turn off Relay 2")
                    fun[0] = fun[0] | 0x02
                    relay_devices[1].off()
                elif b == 51:  # '3'
                    print("Turn off Relay 3")
                    fun[0] = fun[0] | 0x04
                    relay_devices[2].off()
                elif b == 52:  # '4'
                    print("Turn off Relay 4")
                    fun[0] = fun[0] | 0x08
                    relay_devices[3].off()
                elif b == 53:  # '5'
                    print("Turn off Relay 5")
                    fun[0] = fun[0] | 0x10
                    relay_devices[4].off()  
                elif b == 54:  # '6'
                    print("Turn off Relay 6")
                    fun[0] = fun[0] | 0x20
                    relay_devices[5].off()
                    
                elif b == 97:  # 'a'
                    print("Turn on Relay 1")
                    fun[0] = fun[0] & 0xfe
                    relay_devices[0].on()
                elif b == 98:  # 'b'
                    print("Turn on Relay 2")
                    fun[0] = fun[0] & 0xfd
                    relay_devices[1].on() 
                elif b == 99:  # 'c'
                    print("Turn on Relay 3")
                    fun[0] = fun[0] & 0xfb
                    relay_devices[2].on() 
                elif b == 100:  # 'd'
                    print("Turn on Relay 4")
                    fun[0] = fun[0] & 0xf7
                    relay_devices[3].on() 
                elif b == 101:  # 'e'
                    print("Turn on Relay 5")
                    fun[0] = fun[0] & 0xef
                    relay_devices[4].on() 
                elif b == 102:  # 'f'
                    print("Turn on Relay 6")
                    fun[0] = fun[0] & 0xdf
                    relay_devices[5].on()                 

            msg1 = can.Message(arbitration_id=0x123, data=data, is_extended_id=False)
            can0.send(msg1)

            msg1 = can.Message(arbitration_id=0x123, data=fun, is_extended_id=False)
            can0.send(msg1)
            
            time.sleep(1)

except KeyboardInterrupt:
    print('Exiting...')

finally:
    can0.shutdown()
    for relay in relay_devices:
        relay.off()
    os.system('sudo ifconfig can0 down')