# -*- coding:utf-8 -*-
from gpiozero import OutputDevice
import serial
import os
import can

import sys

if sys.version_info[0] >= 3:
    input_func = input
else:
    input_func = raw_input

os.system('sudo ip link set can0 type can bitrate 100000')
os.system('sudo ifconfig can0 up')

can0 = can.Bus(channel='can0', interface='socketcan')

msg1 = can.Message(arbitration_id=0x123, data=[0], is_extended_id=False)
can0.send(msg1)

print("You can always send data, press Ctrl + C to exit")
print("Send \"abcdef\" to open relays 1, 2, 3, 4, 5 and 6 respectively")
print("Send \"123456\" to close relays 1, 2, 3, 4, 5 and 6 respectively")

try:
    while True:
        strInput = input_func('\r\nenter some data:') 
        msg = can.Message(arbitration_id=0x123, data=strInput.encode('utf-8')[:8], is_extended_id=False)
        can0.send(msg)
        
        msg1 = can0.recv(10.0)
        if msg1 is None:
            print('No callback data was received.')
        else:
            print("The data received and returned by the slave is : ", msg1.data)
        
        print('The state of the relay is as follows :')
        msg1 = can0.recv(10.0)
        if msg1 is None:
            print('The status of the relay is not received.')
        else:
            for i in range(6):
                if (msg1.data[0] & (1 << i)):
                    print("Relay ", i+1, " off")
                else:
                    print("Relay ", i+1, " on")

except KeyboardInterrupt:
    print('Exiting...')

finally:
    can0.shutdown()
    os.system('sudo ifconfig can0 down')