#include <wiringSerial.h>
#include <wiringPi.h>
#include <stdio.h>
#include <stdlib.h>     //exit()
#include <signal.h>
#include <unistd.h>
#include <string.h>
#include <strings.h>
#include <sys/time.h>

// BCM2835 Pin
// char Relay[]={5, 6, 13, 16, 19, 20};
// wiringPi Pin
char Relay[]={21, 22, 23, 27, 24, 28};

void  Handler(int signo)
{
    //System Exit
    printf("\r\nHandler:serialClose \r\n");
    exit(0);
}

int main(void)
{
    int i=0;
	printf("\r\n");
	// if(wiringPiSetupGpio() < 0) //use BCM2835 Pin number table
    if(wiringPiSetup() < 0) //use wiringPi Pin number table
	{ 
	    printf("set wiringPi lib failed	!!! \r\n");
		printf("\r\n");
	    return 1;
    } 
	else 
	{
        printf("set wiringPi lib success  !!! \r\n");
    }
    
    for(i=0; i<sizeof(Relay); i++)
    {
        pinMode(Relay[i], OUTPUT);
    }
    
    for(i=0; i<sizeof(Relay); i++)
    {
        digitalWrite(Relay[i], LOW);
    }
	
    for(i=0; i<sizeof(Relay); i++)
    {
        printf("Turn on Relay %d\r\n",i+1);
        digitalWrite(Relay[i], HIGH);
        delay(500);
    }
    
    for(i=0; i<sizeof(Relay); i++)
    {
        printf("Turn off Relay %d\r\n",i+1);
        digitalWrite(Relay[i], LOW);
        delay(500);
    }

	
	
	 // Exception handling:ctrl + c
    signal(SIGINT, Handler);
}




